
;CodeVisionAVR C Compiler V3.06 UL Advanced
;(C) Copyright 1998-2013 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATxmega256A3B
;Program type           : Application
;Clock frequency        : 32,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 4096 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATxmega256A3B
	#pragma AVRPART MEMORY PROG_FLASH 270336
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 16384
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x2000

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU CCP=0x34
	.EQU RAMPD=0x38
	.EQU RAMPX=0x39
	.EQU RAMPY=0x3A
	.EQU RAMPZ=0x3B
	.EQU EIND=0x3C
	.EQU WDT_CTRL=0x80
	.EQU PMIC_CTRL=0xA2
	.EQU NVM_ADDR0=0X01C0
	.EQU NVM_ADDR1=NVM_ADDR0+1
	.EQU NVM_ADDR2=NVM_ADDR1+1
	.EQU NVM_DATA0=NVM_ADDR0+4
	.EQU NVM_CMD=NVM_ADDR0+0xA
	.EQU NVM_CTRLA=NVM_ADDR0+0xB
	.EQU NVM_CTRLB=NVM_ADDR0+0xC
	.EQU NVM_STATUS=NVM_ADDR0+0xF
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIO0=0x00
	.EQU GPIO1=0x01
	.EQU GPIO2=0x02
	.EQU GPIO3=0x03
	.EQU GPIO4=0x04
	.EQU GPIO5=0x05
	.EQU GPIO6=0x06
	.EQU GPIO7=0x07
	.EQU GPIO8=0x08
	.EQU GPIO9=0x09
	.EQU GPIO10=0x0A
	.EQU GPIO11=0x0B
	.EQU GPIO12=0x0C
	.EQU GPIO13=0x0D
	.EQU GPIO14=0x0E
	.EQU GPIO15=0x0F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x2000
	.EQU __SRAM_END=0x5FFF
	.EQU __DSTACK_SIZE=0x1000
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _tx_wr_index_usartc0=R2
	.DEF _tx_wr_index_usartc0_msb=R3
	.DEF _tx_rd_index_usartc0=R4
	.DEF _tx_rd_index_usartc0_msb=R5
	.DEF _tx_counter_usartc0=R6
	.DEF _tx_counter_usartc0_msb=R7

;GPIO0-GPIO15 INITIALIZATION VALUES
	.EQU __GPIO0_INIT=0x00
	.EQU __GPIO1_INIT=0x00
	.EQU __GPIO2_INIT=0x00
	.EQU __GPIO3_INIT=0x00
	.EQU __GPIO4_INIT=0x00
	.EQU __GPIO5_INIT=0x00
	.EQU __GPIO6_INIT=0x00
	.EQU __GPIO7_INIT=0x00
	.EQU __GPIO8_INIT=0x00
	.EQU __GPIO9_INIT=0x00
	.EQU __GPIO10_INIT=0x00
	.EQU __GPIO11_INIT=0x00
	.EQU __GPIO12_INIT=0x00
	.EQU __GPIO13_INIT=0x00
	.EQU __GPIO14_INIT=0x00
	.EQU __GPIO15_INIT=0x00

;GLOBAL REGISTER VARIABLES INITIALIZATION VALUES
	.EQU __R2_INIT=0x00
	.EQU __R3_INIT=0x00
	.EQU __R4_INIT=0x00
	.EQU __R5_INIT=0x00
	.EQU __R6_INIT=0x00
	.EQU __R7_INIT=0x00
	.EQU __R8_INIT=0x00
	.EQU __R9_INIT=0x00
	.EQU __R10_INIT=0x00
	.EQU __R11_INIT=0x00
	.EQU __R12_INIT=0x00
	.EQU __R13_INIT=0x00
	.EQU __R14_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usartc0_tx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

__RESET:
	CLI
	CLR  R30
	OUT  RAMPD,R30
	OUT  RAMPX,R30
	OUT  RAMPY,R30

;MEMORY MAPPED EEPROM ACCESS IS USED
	LDS  R31,NVM_CTRLB
	ORI  R31,0x08
	STS  NVM_CTRLB,R31

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,0xD8
	OUT  CCP,R31
	STS  PMIC_CTRL,R30

;DISABLE WATCHDOG
	LDS  R26,WDT_CTRL
	CBR  R26,2
	SBR  R26,1
	OUT  CCP,R31
	STS  WDT_CTRL,R26

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

	OUT  RAMPZ,R24

	OUT  EIND,R24

;GPIO0-GPIO15 INITIALIZATION
	LDI  R30,__GPIO0_INIT
	OUT  GPIO0,R30
	;__GPIO1_INIT = __GPIO0_INIT
	OUT  GPIO1,R30
	;__GPIO2_INIT = __GPIO0_INIT
	OUT  GPIO2,R30
	;__GPIO3_INIT = __GPIO0_INIT
	OUT  GPIO3,R30
	;__GPIO4_INIT = __GPIO0_INIT
	OUT  GPIO4,R30
	;__GPIO5_INIT = __GPIO0_INIT
	OUT  GPIO5,R30
	;__GPIO6_INIT = __GPIO0_INIT
	OUT  GPIO6,R30
	;__GPIO7_INIT = __GPIO0_INIT
	OUT  GPIO7,R30
	;__GPIO8_INIT = __GPIO0_INIT
	OUT  GPIO8,R30
	;__GPIO9_INIT = __GPIO0_INIT
	OUT  GPIO9,R30
	;__GPIO10_INIT = __GPIO0_INIT
	OUT  GPIO10,R30
	;__GPIO11_INIT = __GPIO0_INIT
	OUT  GPIO11,R30
	;__GPIO12_INIT = __GPIO0_INIT
	OUT  GPIO12,R30
	;__GPIO13_INIT = __GPIO0_INIT
	OUT  GPIO13,R30
	;__GPIO14_INIT = __GPIO0_INIT
	OUT  GPIO14,R30
	;__GPIO15_INIT = __GPIO0_INIT
	OUT  GPIO15,R30

;GLOBAL REGISTER VARIABLES INITIALIZATION
	;__R2_INIT = __GPIO0_INIT
	MOV  R2,R30
	;__R3_INIT = __GPIO0_INIT
	MOV  R3,R30
	;__R4_INIT = __GPIO0_INIT
	MOV  R4,R30
	;__R5_INIT = __GPIO0_INIT
	MOV  R5,R30
	;__R6_INIT = __GPIO0_INIT
	MOV  R6,R30
	;__R7_INIT = __GPIO0_INIT
	MOV  R7,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0x3000

	.CSEG
;// I/O Registers definitions
;#include <io.h>
;
;// Standard Input/Output functions
;#include <stdio.h>
;#include <stdbool.h>
;#include <delay.h>
;
;// Anschluss
;// Rot + 3,5V
;// Weis - GND
;// Grn Data PORTC.3
;
;// Low Speed Mode
;// 400Kbps = 2,50us/bit
;
;// LOW
;//    _________               __
;//   |         |             |
;//   |  0,5us  |    2,0us    |
;// __|         |_____________|
;
;// HIGH
;//    ___________             __
;//   |           |           |
;//   |   1,2us   |   1,3us   |
;// __|           |___________|
;
;
;// High Speed Mode
;// 800Kbps = 1,25us/bit
;
;// LOW
;//    _________               __
;//   |         |             |
;//   |  0,25us |    1,0us    |
;// __|         |_____________|
;
;// HIGH
;//    ___________             __
;//   |           |           |
;//   |   0,6us   |   0,65us  |
;// __|           |___________|
;
;
;// Declare your global variables here
;
;// System Clocks initialization
;void system_clocks_init(void)
; 0000 0032 {

	.CSEG
_system_clocks_init:
; .FSTART _system_clocks_init
; 0000 0033 	unsigned char n,s;
; 0000 0034 
; 0000 0035 	// Optimize for speed
; 0000 0036 	#pragma optsize-
; 0000 0037 	// Save interrupts enabled/disabled state
; 0000 0038 	s=SREG;
	ST   -Y,R17
	ST   -Y,R16
;	n -> R17
;	s -> R16
	IN   R16,63
; 0000 0039 	// Disable interrupts
; 0000 003A 	#asm("cli")
	cli
; 0000 003B 
; 0000 003C 	// Internal 32 MHz RC oscillator initialization
; 0000 003D 	// Enable the internal 32 MHz RC oscillator
; 0000 003E 	OSC.CTRL|=OSC_RC32MEN_bm;
	LDS  R30,80
	ORI  R30,2
	STS  80,R30
; 0000 003F 
; 0000 0040 	// System Clock prescaler A division factor: 1
; 0000 0041 	// System Clock prescalers B & C division factors: B:1, C:1
; 0000 0042 	// ClkPer4: 32000,000 kHz
; 0000 0043 	// ClkPer2: 32000,000 kHz
; 0000 0044 	// ClkPer:  32000,000 kHz
; 0000 0045 	// ClkCPU:  32000,000 kHz
; 0000 0046 	n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
; 0000 0047 	CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;
	LDS  R30,65
	ANDI R30,LOW(0x80)
	MOV  R17,R30
; 0000 0048 	CCP=CCP_IOREG_gc;
	LDI  R30,LOW(216)
	OUT  0x34,R30
; 0000 0049 	CLK.PSCTRL=n;
	STS  65,R17
; 0000 004A 
; 0000 004B 	// Disable the auto-calibration of the internal 32 MHz RC oscillator
; 0000 004C 	DFLLRC32M.CTRL&= ~DFLL_ENABLE_bm;
	LDS  R30,96
	ANDI R30,0xFE
	STS  96,R30
; 0000 004D 
; 0000 004E 	// Wait for the internal 32 MHz RC oscillator to stabilize
; 0000 004F 	while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);
_0x3:
	LDS  R30,81
	ANDI R30,LOW(0x2)
	BREQ _0x3
; 0000 0050 
; 0000 0051 	// Select the system clock source: 32 MHz Internal RC Osc.
; 0000 0052 	n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC32M_gc;
	LDS  R30,64
	ANDI R30,LOW(0xF8)
	ORI  R30,1
	MOV  R17,R30
; 0000 0053 	CCP=CCP_IOREG_gc;
	LDI  R30,LOW(216)
	OUT  0x34,R30
; 0000 0054 	CLK.CTRL=n;
	STS  64,R17
; 0000 0055 
; 0000 0056 	// Disable the unused oscillators: 2 MHz, internal 32 kHz, external clock/crystal oscillator, PLL
; 0000 0057 	OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);
	LDS  R30,80
	ANDI R30,LOW(0xE2)
	STS  80,R30
; 0000 0058 
; 0000 0059 	// ClkPer output disabled
; 0000 005A 	PORTCFG.CLKEVOUT&= ~PORTCFG_CLKOUT_gm;
	LDS  R30,180
	ANDI R30,LOW(0xFC)
	STS  180,R30
; 0000 005B 	// Restore interrupts enabled/disabled state
; 0000 005C 	SREG=s;
	OUT  0x3F,R16
; 0000 005D 	// Restore optimization for size if needed
; 0000 005E 	#pragma optsize_default
; 0000 005F }
	LD   R16,Y+
	LD   R17,Y+
	RET
; .FEND
;
;// Ports initialization
;void ports_init(void)
; 0000 0063 {
_ports_init:
; .FSTART _ports_init
; 0000 0064 	// PORTA initialization
; 0000 0065 	// OUT register
; 0000 0066 	PORTA.OUT=0x00;
	LDI  R30,LOW(0)
	STS  1540,R30
; 0000 0067 	// Pin0: Input
; 0000 0068 	// Pin1: Input
; 0000 0069 	// Pin2: Input
; 0000 006A 	// Pin3: Input
; 0000 006B 	// Pin4: Input
; 0000 006C 	// Pin5: Input
; 0000 006D 	// Pin6: Input
; 0000 006E 	// Pin7: Input
; 0000 006F 	PORTA.DIR=0x00;
	STS  1536,R30
; 0000 0070 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 0071 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 0072 	// Pin0 Inverted: Off
; 0000 0073 	// Pin0 Slew Rate Limitation: Off
; 0000 0074 	PORTA.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1552,R30
; 0000 0075 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 0076 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 0077 	// Pin1 Inverted: Off
; 0000 0078 	// Pin1 Slew Rate Limitation: Off
; 0000 0079 	PORTA.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1553,R30
; 0000 007A 	// Pin2 Output/Pull configuration: Totempole/No
; 0000 007B 	// Pin2 Input/Sense configuration: Sense both edges
; 0000 007C 	// Pin2 Inverted: Off
; 0000 007D 	// Pin2 Slew Rate Limitation: Off
; 0000 007E 	PORTA.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1554,R30
; 0000 007F 	// Pin3 Output/Pull configuration: Totempole/No
; 0000 0080 	// Pin3 Input/Sense configuration: Sense both edges
; 0000 0081 	// Pin3 Inverted: Off
; 0000 0082 	// Pin3 Slew Rate Limitation: Off
; 0000 0083 	PORTA.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1555,R30
; 0000 0084 	// Pin4 Output/Pull configuration: Totempole/No
; 0000 0085 	// Pin4 Input/Sense configuration: Sense both edges
; 0000 0086 	// Pin4 Inverted: Off
; 0000 0087 	// Pin4 Slew Rate Limitation: Off
; 0000 0088 	PORTA.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1556,R30
; 0000 0089 	// Pin5 Output/Pull configuration: Totempole/No
; 0000 008A 	// Pin5 Input/Sense configuration: Sense both edges
; 0000 008B 	// Pin5 Inverted: Off
; 0000 008C 	// Pin5 Slew Rate Limitation: Off
; 0000 008D 	PORTA.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1557,R30
; 0000 008E 	// Pin6 Output/Pull configuration: Totempole/No
; 0000 008F 	// Pin6 Input/Sense configuration: Sense both edges
; 0000 0090 	// Pin6 Inverted: Off
; 0000 0091 	// Pin6 Slew Rate Limitation: Off
; 0000 0092 	PORTA.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1558,R30
; 0000 0093 	// Pin7 Output/Pull configuration: Totempole/No
; 0000 0094 	// Pin7 Input/Sense configuration: Sense both edges
; 0000 0095 	// Pin7 Inverted: Off
; 0000 0096 	// Pin7 Slew Rate Limitation: Off
; 0000 0097 	PORTA.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1559,R30
; 0000 0098 	// Interrupt 0 level: Disabled
; 0000 0099 	// Interrupt 1 level: Disabled
; 0000 009A 	PORTA.INTCTRL=(PORTA.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 009B 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1545
	ANDI R30,LOW(0xF0)
	STS  1545,R30
; 0000 009C 	// Pin0 Pin Change interrupt 0: Off
; 0000 009D 	// Pin1 Pin Change interrupt 0: Off
; 0000 009E 	// Pin2 Pin Change interrupt 0: Off
; 0000 009F 	// Pin3 Pin Change interrupt 0: Off
; 0000 00A0 	// Pin4 Pin Change interrupt 0: Off
; 0000 00A1 	// Pin5 Pin Change interrupt 0: Off
; 0000 00A2 	// Pin6 Pin Change interrupt 0: Off
; 0000 00A3 	// Pin7 Pin Change interrupt 0: Off
; 0000 00A4 	PORTA.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1546,R30
; 0000 00A5 	// Pin0 Pin Change interrupt 1: Off
; 0000 00A6 	// Pin1 Pin Change interrupt 1: Off
; 0000 00A7 	// Pin2 Pin Change interrupt 1: Off
; 0000 00A8 	// Pin3 Pin Change interrupt 1: Off
; 0000 00A9 	// Pin4 Pin Change interrupt 1: Off
; 0000 00AA 	// Pin5 Pin Change interrupt 1: Off
; 0000 00AB 	// Pin6 Pin Change interrupt 1: Off
; 0000 00AC 	// Pin7 Pin Change interrupt 1: Off
; 0000 00AD 	PORTA.INT1MASK=0x00;
	STS  1547,R30
; 0000 00AE 
; 0000 00AF 	// PORTB initialization
; 0000 00B0 	// OUT register
; 0000 00B1 	PORTB.OUT=0x00;
	STS  1572,R30
; 0000 00B2 	// Pin0: Input
; 0000 00B3 	// Pin1: Input
; 0000 00B4 	// Pin2: Input
; 0000 00B5 	// Pin3: Input
; 0000 00B6 	// Pin4: Input
; 0000 00B7 	// Pin5: Input
; 0000 00B8 	// Pin6: Input
; 0000 00B9 	// Pin7: Input
; 0000 00BA 	PORTB.DIR=0x00;
	STS  1568,R30
; 0000 00BB 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 00BC 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 00BD 	// Pin0 Inverted: Off
; 0000 00BE 	// Pin0 Slew Rate Limitation: Off
; 0000 00BF 	PORTB.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1584,R30
; 0000 00C0 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 00C1 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 00C2 	// Pin1 Inverted: Off
; 0000 00C3 	// Pin1 Slew Rate Limitation: Off
; 0000 00C4 	PORTB.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1585,R30
; 0000 00C5 	// Pin2 Output/Pull configuration: Totempole/No
; 0000 00C6 	// Pin2 Input/Sense configuration: Sense both edges
; 0000 00C7 	// Pin2 Inverted: Off
; 0000 00C8 	// Pin2 Slew Rate Limitation: Off
; 0000 00C9 	PORTB.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1586,R30
; 0000 00CA 	// Pin3 Output/Pull configuration: Totempole/No
; 0000 00CB 	// Pin3 Input/Sense configuration: Sense both edges
; 0000 00CC 	// Pin3 Inverted: Off
; 0000 00CD 	// Pin3 Slew Rate Limitation: Off
; 0000 00CE 	PORTB.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1587,R30
; 0000 00CF 	// Pin4 Output/Pull configuration: Totempole/No
; 0000 00D0 	// Pin4 Input/Sense configuration: Sense both edges
; 0000 00D1 	// Pin4 Inverted: Off
; 0000 00D2 	// Pin4 Slew Rate Limitation: Off
; 0000 00D3 	PORTB.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1588,R30
; 0000 00D4 	// Pin5 Output/Pull configuration: Totempole/No
; 0000 00D5 	// Pin5 Input/Sense configuration: Sense both edges
; 0000 00D6 	// Pin5 Inverted: Off
; 0000 00D7 	// Pin5 Slew Rate Limitation: Off
; 0000 00D8 	PORTB.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1589,R30
; 0000 00D9 	// Pin6 Output/Pull configuration: Totempole/No
; 0000 00DA 	// Pin6 Input/Sense configuration: Sense both edges
; 0000 00DB 	// Pin6 Inverted: Off
; 0000 00DC 	// Pin6 Slew Rate Limitation: Off
; 0000 00DD 	PORTB.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1590,R30
; 0000 00DE 	// Pin7 Output/Pull configuration: Totempole/No
; 0000 00DF 	// Pin7 Input/Sense configuration: Sense both edges
; 0000 00E0 	// Pin7 Inverted: Off
; 0000 00E1 	// Pin7 Slew Rate Limitation: Off
; 0000 00E2 	PORTB.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1591,R30
; 0000 00E3 	// Interrupt 0 level: Disabled
; 0000 00E4 	// Interrupt 1 level: Disabled
; 0000 00E5 	PORTB.INTCTRL=(PORTB.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 00E6 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1577
	ANDI R30,LOW(0xF0)
	STS  1577,R30
; 0000 00E7 	// Pin0 Pin Change interrupt 0: Off
; 0000 00E8 	// Pin1 Pin Change interrupt 0: Off
; 0000 00E9 	// Pin2 Pin Change interrupt 0: Off
; 0000 00EA 	// Pin3 Pin Change interrupt 0: Off
; 0000 00EB 	// Pin4 Pin Change interrupt 0: Off
; 0000 00EC 	// Pin5 Pin Change interrupt 0: Off
; 0000 00ED 	// Pin6 Pin Change interrupt 0: Off
; 0000 00EE 	// Pin7 Pin Change interrupt 0: Off
; 0000 00EF 	PORTB.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1578,R30
; 0000 00F0 	// Pin0 Pin Change interrupt 1: Off
; 0000 00F1 	// Pin1 Pin Change interrupt 1: Off
; 0000 00F2 	// Pin2 Pin Change interrupt 1: Off
; 0000 00F3 	// Pin3 Pin Change interrupt 1: Off
; 0000 00F4 	// Pin4 Pin Change interrupt 1: Off
; 0000 00F5 	// Pin5 Pin Change interrupt 1: Off
; 0000 00F6 	// Pin6 Pin Change interrupt 1: Off
; 0000 00F7 	// Pin7 Pin Change interrupt 1: Off
; 0000 00F8 	PORTB.INT1MASK=0x00;
	STS  1579,R30
; 0000 00F9 
; 0000 00FA 	// PORTC initialization
; 0000 00FB 	// OUT register
; 0000 00FC 	PORTC.OUT=0x00;
	STS  1604,R30
; 0000 00FD 	// Pin0: Input
; 0000 00FE 	// Pin1: Output
; 0000 00FF 	// Pin2: Input
; 0000 0100 	// Pin3: Output
; 0000 0101 	// Pin4: Input
; 0000 0102 	// Pin5: Input
; 0000 0103 	// Pin6: Input
; 0000 0104 	// Pin7: Input
; 0000 0105 	PORTC.DIR=0x00;//0x0A;
	STS  1600,R30
; 0000 0106 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 0107 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 0108 	// Pin0 Inverted: Off
; 0000 0109 	// Pin0 Slew Rate Limitation: Off
; 0000 010A 	PORTC.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1616,R30
; 0000 010B 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 010C 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 010D 	// Pin1 Inverted: Off
; 0000 010E 	// Pin1 Slew Rate Limitation: Off
; 0000 010F 	PORTC.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1617,R30
; 0000 0110 	// Pin2 Output/Pull configuration: Totempole/No
; 0000 0111 	// Pin2 Input/Sense configuration: Sense both edges
; 0000 0112 	// Pin2 Inverted: Off
; 0000 0113 	// Pin2 Slew Rate Limitation: Off
; 0000 0114 	PORTC.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1618,R30
; 0000 0115 	// Pin3 Output/Pull configuration: Totempole/No
; 0000 0116 	// Pin3 Input/Sense configuration: Sense both edges
; 0000 0117 	// Pin3 Inverted: On
; 0000 0118 	// Pin3 Slew Rate Limitation: Off
; 0000 0119 //	PORTC.PIN3CTRL=PORT_INVEN_bm | PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
; 0000 011A 	PORTC.PIN3CTRL= PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1619,R30
; 0000 011B 	// Pin4 Output/Pull configuration: Totempole/No
; 0000 011C 	// Pin4 Input/Sense configuration: Sense both edges
; 0000 011D 	// Pin4 Inverted: Off
; 0000 011E 	// Pin4 Slew Rate Limitation: Off
; 0000 011F 	PORTC.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1620,R30
; 0000 0120 	// Pin5 Output/Pull configuration: Totempole/No
; 0000 0121 	// Pin5 Input/Sense configuration: Sense both edges
; 0000 0122 	// Pin5 Inverted: Off
; 0000 0123 	// Pin5 Slew Rate Limitation: Off
; 0000 0124 	PORTC.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1621,R30
; 0000 0125 	// Pin6 Output/Pull configuration: Totempole/No
; 0000 0126 	// Pin6 Input/Sense configuration: Sense both edges
; 0000 0127 	// Pin6 Inverted: Off
; 0000 0128 	// Pin6 Slew Rate Limitation: Off
; 0000 0129 	PORTC.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1622,R30
; 0000 012A 	// Pin7 Output/Pull configuration: Totempole/No
; 0000 012B 	// Pin7 Input/Sense configuration: Sense both edges
; 0000 012C 	// Pin7 Inverted: Off
; 0000 012D 	// Pin7 Slew Rate Limitation: Off
; 0000 012E 	PORTC.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1623,R30
; 0000 012F 	// Interrupt 0 level: Disabled
; 0000 0130 	// Interrupt 1 level: Disabled
; 0000 0131 	PORTC.INTCTRL=(PORTC.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) | PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1609
	ANDI R30,LOW(0xF0)
	STS  1609,R30
; 0000 0132 	// Pin0 Pin Change interrupt 0: Off
; 0000 0133 	// Pin1 Pin Change interrupt 0: Off
; 0000 0134 	// Pin2 Pin Change interrupt 0: Off
; 0000 0135 	// Pin3 Pin Change interrupt 0: Off
; 0000 0136 	// Pin4 Pin Change interrupt 0: Off
; 0000 0137 	// Pin5 Pin Change interrupt 0: Off
; 0000 0138 	// Pin6 Pin Change interrupt 0: Off
; 0000 0139 	// Pin7 Pin Change interrupt 0: Off
; 0000 013A 	PORTC.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1610,R30
; 0000 013B 	// Pin0 Pin Change interrupt 1: Off
; 0000 013C 	// Pin1 Pin Change interrupt 1: Off
; 0000 013D 	// Pin2 Pin Change interrupt 1: Off
; 0000 013E 	// Pin3 Pin Change interrupt 1: Off
; 0000 013F 	// Pin4 Pin Change interrupt 1: Off
; 0000 0140 	// Pin5 Pin Change interrupt 1: Off
; 0000 0141 	// Pin6 Pin Change interrupt 1: Off
; 0000 0142 	// Pin7 Pin Change interrupt 1: Off
; 0000 0143 	PORTC.INT1MASK=0x00;
	STS  1611,R30
; 0000 0144 
; 0000 0145 	// Hier einschalten, damit am Anfang keine 1 kommt
; 0000 0146 	PORTC.OUT=0x00;
	STS  1604,R30
; 0000 0147 	PORTC.DIR=0x1A;
	LDI  R30,LOW(26)
	STS  1600,R30
; 0000 0148 
; 0000 0149 	// PORTD initialization
; 0000 014A 	// OUT register
; 0000 014B 	PORTD.OUT=0x00;
	LDI  R30,LOW(0)
	STS  1636,R30
; 0000 014C 	// Pin0: Input
; 0000 014D 	// Pin1: Input
; 0000 014E 	// Pin2: Input
; 0000 014F 	// Pin3: Input
; 0000 0150 	// Pin4: Input
; 0000 0151 	// Pin5: Input
; 0000 0152 	// Pin6: Input
; 0000 0153 	// Pin7: Input
; 0000 0154 	PORTD.DIR=0x00;
	STS  1632,R30
; 0000 0155 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 0156 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 0157 	// Pin0 Inverted: Off
; 0000 0158 	// Pin0 Slew Rate Limitation: Off
; 0000 0159 	PORTD.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1648,R30
; 0000 015A 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 015B 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 015C 	// Pin1 Inverted: Off
; 0000 015D 	// Pin1 Slew Rate Limitation: Off
; 0000 015E 	PORTD.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1649,R30
; 0000 015F 	// Pin2 Output/Pull configuration: Totempole/No
; 0000 0160 	// Pin2 Input/Sense configuration: Sense both edges
; 0000 0161 	// Pin2 Inverted: Off
; 0000 0162 	// Pin2 Slew Rate Limitation: Off
; 0000 0163 	PORTD.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1650,R30
; 0000 0164 	// Pin3 Output/Pull configuration: Totempole/No
; 0000 0165 	// Pin3 Input/Sense configuration: Sense both edges
; 0000 0166 	// Pin3 Inverted: Off
; 0000 0167 	// Pin3 Slew Rate Limitation: Off
; 0000 0168 	PORTD.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1651,R30
; 0000 0169 	// Pin4 Output/Pull configuration: Totempole/No
; 0000 016A 	// Pin4 Input/Sense configuration: Sense both edges
; 0000 016B 	// Pin4 Inverted: Off
; 0000 016C 	// Pin4 Slew Rate Limitation: Off
; 0000 016D 	PORTD.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1652,R30
; 0000 016E 	// Pin5 Output/Pull configuration: Totempole/No
; 0000 016F 	// Pin5 Input/Sense configuration: Sense both edges
; 0000 0170 	// Pin5 Inverted: Off
; 0000 0171 	// Pin5 Slew Rate Limitation: Off
; 0000 0172 	PORTD.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1653,R30
; 0000 0173 	// Pin6 Output/Pull configuration: Totempole/No
; 0000 0174 	// Pin6 Input/Sense configuration: Sense both edges
; 0000 0175 	// Pin6 Inverted: Off
; 0000 0176 	// Pin6 Slew Rate Limitation: Off
; 0000 0177 	PORTD.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1654,R30
; 0000 0178 	// Pin7 Output/Pull configuration: Totempole/No
; 0000 0179 	// Pin7 Input/Sense configuration: Sense both edges
; 0000 017A 	// Pin7 Inverted: Off
; 0000 017B 	// Pin7 Slew Rate Limitation: Off
; 0000 017C 	PORTD.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1655,R30
; 0000 017D 	// Interrupt 0 level: Disabled
; 0000 017E 	// Interrupt 1 level: Disabled
; 0000 017F 	PORTD.INTCTRL=(PORTD.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0180 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1641
	ANDI R30,LOW(0xF0)
	STS  1641,R30
; 0000 0181 	// Pin0 Pin Change interrupt 0: Off
; 0000 0182 	// Pin1 Pin Change interrupt 0: Off
; 0000 0183 	// Pin2 Pin Change interrupt 0: Off
; 0000 0184 	// Pin3 Pin Change interrupt 0: Off
; 0000 0185 	// Pin4 Pin Change interrupt 0: Off
; 0000 0186 	// Pin5 Pin Change interrupt 0: Off
; 0000 0187 	// Pin6 Pin Change interrupt 0: Off
; 0000 0188 	// Pin7 Pin Change interrupt 0: Off
; 0000 0189 	PORTD.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1642,R30
; 0000 018A 	// Pin0 Pin Change interrupt 1: Off
; 0000 018B 	// Pin1 Pin Change interrupt 1: Off
; 0000 018C 	// Pin2 Pin Change interrupt 1: Off
; 0000 018D 	// Pin3 Pin Change interrupt 1: Off
; 0000 018E 	// Pin4 Pin Change interrupt 1: Off
; 0000 018F 	// Pin5 Pin Change interrupt 1: Off
; 0000 0190 	// Pin6 Pin Change interrupt 1: Off
; 0000 0191 	// Pin7 Pin Change interrupt 1: Off
; 0000 0192 	PORTD.INT1MASK=0x00;
	STS  1643,R30
; 0000 0193 
; 0000 0194 	// PORTE initialization
; 0000 0195 	// OUT register
; 0000 0196 	PORTE.OUT=0x00;
	STS  1668,R30
; 0000 0197 	// Pin0: Input
; 0000 0198 	// Pin1: Input
; 0000 0199 	// Pin2: Input
; 0000 019A 	// Pin3: Input
; 0000 019B 	// Pin4: Input
; 0000 019C 	// Pin5: Input
; 0000 019D 	// Pin6: Input
; 0000 019E 	// Pin7: Input
; 0000 019F 	PORTE.DIR=0x00;
	STS  1664,R30
; 0000 01A0 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 01A1 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 01A2 	// Pin0 Inverted: Off
; 0000 01A3 	// Pin0 Slew Rate Limitation: Off
; 0000 01A4 	PORTE.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1680,R30
; 0000 01A5 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 01A6 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 01A7 	// Pin1 Inverted: Off
; 0000 01A8 	// Pin1 Slew Rate Limitation: Off
; 0000 01A9 	PORTE.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1681,R30
; 0000 01AA 	// Pin2 Output/Pull configuration: Totempole/No
; 0000 01AB 	// Pin2 Input/Sense configuration: Sense both edges
; 0000 01AC 	// Pin2 Inverted: Off
; 0000 01AD 	// Pin2 Slew Rate Limitation: Off
; 0000 01AE 	PORTE.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1682,R30
; 0000 01AF 	// Pin3 Output/Pull configuration: Totempole/No
; 0000 01B0 	// Pin3 Input/Sense configuration: Sense both edges
; 0000 01B1 	// Pin3 Inverted: Off
; 0000 01B2 	// Pin3 Slew Rate Limitation: Off
; 0000 01B3 	PORTE.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1683,R30
; 0000 01B4 	// Pin4 Output/Pull configuration: Totempole/No
; 0000 01B5 	// Pin4 Input/Sense configuration: Sense both edges
; 0000 01B6 	// Pin4 Inverted: Off
; 0000 01B7 	// Pin4 Slew Rate Limitation: Off
; 0000 01B8 	PORTE.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1684,R30
; 0000 01B9 	// Pin5 Output/Pull configuration: Totempole/No
; 0000 01BA 	// Pin5 Input/Sense configuration: Sense both edges
; 0000 01BB 	// Pin5 Inverted: Off
; 0000 01BC 	// Pin5 Slew Rate Limitation: Off
; 0000 01BD 	PORTE.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1685,R30
; 0000 01BE 	// Pin6 Output/Pull configuration: Totempole/No
; 0000 01BF 	// Pin6 Input/Sense configuration: Sense both edges
; 0000 01C0 	// Pin6 Inverted: Off
; 0000 01C1 	// Pin6 Slew Rate Limitation: Off
; 0000 01C2 	PORTE.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1686,R30
; 0000 01C3 	// Pin7 Output/Pull configuration: Totempole/No
; 0000 01C4 	// Pin7 Input/Sense configuration: Sense both edges
; 0000 01C5 	// Pin7 Inverted: Off
; 0000 01C6 	// Pin7 Slew Rate Limitation: Off
; 0000 01C7 	PORTE.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1687,R30
; 0000 01C8 	// Interrupt 0 level: Disabled
; 0000 01C9 	// Interrupt 1 level: Disabled
; 0000 01CA 	PORTE.INTCTRL=(PORTE.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 01CB 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1673
	ANDI R30,LOW(0xF0)
	STS  1673,R30
; 0000 01CC 	// Pin0 Pin Change interrupt 0: Off
; 0000 01CD 	// Pin1 Pin Change interrupt 0: Off
; 0000 01CE 	// Pin2 Pin Change interrupt 0: Off
; 0000 01CF 	// Pin3 Pin Change interrupt 0: Off
; 0000 01D0 	// Pin4 Pin Change interrupt 0: Off
; 0000 01D1 	// Pin5 Pin Change interrupt 0: Off
; 0000 01D2 	// Pin6 Pin Change interrupt 0: Off
; 0000 01D3 	// Pin7 Pin Change interrupt 0: Off
; 0000 01D4 	PORTE.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1674,R30
; 0000 01D5 	// Pin0 Pin Change interrupt 1: Off
; 0000 01D6 	// Pin1 Pin Change interrupt 1: Off
; 0000 01D7 	// Pin2 Pin Change interrupt 1: Off
; 0000 01D8 	// Pin3 Pin Change interrupt 1: Off
; 0000 01D9 	// Pin4 Pin Change interrupt 1: Off
; 0000 01DA 	// Pin5 Pin Change interrupt 1: Off
; 0000 01DB 	// Pin6 Pin Change interrupt 1: Off
; 0000 01DC 	// Pin7 Pin Change interrupt 1: Off
; 0000 01DD 	PORTE.INT1MASK=0x00;
	STS  1675,R30
; 0000 01DE 
; 0000 01DF 	// PORTF initialization
; 0000 01E0 	// OUT register
; 0000 01E1 	PORTF.OUT=0x00;
	STS  1700,R30
; 0000 01E2 	// Pin0: Input
; 0000 01E3 	// Pin1: Input
; 0000 01E4 	// Pin2: Input
; 0000 01E5 	// Pin3: Input
; 0000 01E6 	// Pin4: Input
; 0000 01E7 	// Pin6: Input
; 0000 01E8 	// Pin7: Input
; 0000 01E9 	PORTF.DIR=0x00;
	STS  1696,R30
; 0000 01EA 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 01EB 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 01EC 	// Pin0 Inverted: Off
; 0000 01ED 	// Pin0 Slew Rate Limitation: Off
; 0000 01EE 	PORTF.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1712,R30
; 0000 01EF 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 01F0 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 01F1 	// Pin1 Inverted: Off
; 0000 01F2 	// Pin1 Slew Rate Limitation: Off
; 0000 01F3 	PORTF.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1713,R30
; 0000 01F4 	// Pin2 Output/Pull configuration: Totempole/No
; 0000 01F5 	// Pin2 Input/Sense configuration: Sense both edges
; 0000 01F6 	// Pin2 Inverted: Off
; 0000 01F7 	// Pin2 Slew Rate Limitation: Off
; 0000 01F8 	PORTF.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1714,R30
; 0000 01F9 	// Pin3 Output/Pull configuration: Totempole/No
; 0000 01FA 	// Pin3 Input/Sense configuration: Sense both edges
; 0000 01FB 	// Pin3 Inverted: Off
; 0000 01FC 	// Pin3 Slew Rate Limitation: Off
; 0000 01FD 	PORTF.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1715,R30
; 0000 01FE 	// Pin4 Output/Pull configuration: Totempole/No
; 0000 01FF 	// Pin4 Input/Sense configuration: Sense both edges
; 0000 0200 	// Pin4 Inverted: Off
; 0000 0201 	// Pin4 Slew Rate Limitation: Off
; 0000 0202 	PORTF.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1716,R30
; 0000 0203 	// Pin6 Output/Pull configuration: Totempole/No
; 0000 0204 	// Pin6 Input/Sense configuration: Sense both edges
; 0000 0205 	// Pin6 Inverted: Off
; 0000 0206 	// Pin6 Slew Rate Limitation: Off
; 0000 0207 	PORTF.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1718,R30
; 0000 0208 	// Pin7 Output/Pull configuration: Totempole/No
; 0000 0209 	// Pin7 Input/Sense configuration: Sense both edges
; 0000 020A 	// Pin7 Inverted: Off
; 0000 020B 	// Pin7 Slew Rate Limitation: Off
; 0000 020C 	PORTF.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1719,R30
; 0000 020D 	// Interrupt 0 level: Disabled
; 0000 020E 	// Interrupt 1 level: Disabled
; 0000 020F 	PORTF.INTCTRL=(PORTF.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0210 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1705
	ANDI R30,LOW(0xF0)
	STS  1705,R30
; 0000 0211 	// Pin0 Pin Change interrupt 0: Off
; 0000 0212 	// Pin1 Pin Change interrupt 0: Off
; 0000 0213 	// Pin2 Pin Change interrupt 0: Off
; 0000 0214 	// Pin3 Pin Change interrupt 0: Off
; 0000 0215 	// Pin4 Pin Change interrupt 0: Off
; 0000 0216 	// Pin6 Pin Change interrupt 0: Off
; 0000 0217 	// Pin7 Pin Change interrupt 0: Off
; 0000 0218 	PORTF.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1706,R30
; 0000 0219 	// Pin0 Pin Change interrupt 1: Off
; 0000 021A 	// Pin1 Pin Change interrupt 1: Off
; 0000 021B 	// Pin2 Pin Change interrupt 1: Off
; 0000 021C 	// Pin3 Pin Change interrupt 1: Off
; 0000 021D 	// Pin4 Pin Change interrupt 1: Off
; 0000 021E 	// Pin6 Pin Change interrupt 1: Off
; 0000 021F 	// Pin7 Pin Change interrupt 1: Off
; 0000 0220 	PORTF.INT1MASK=0x00;
	STS  1707,R30
; 0000 0221 
; 0000 0222 	// PORTR initialization
; 0000 0223 	// OUT register
; 0000 0224 	PORTR.OUT=0x00;
	STS  2020,R30
; 0000 0225 	// Pin0: Input
; 0000 0226 	// Pin1: Input
; 0000 0227 	PORTR.DIR=0x00;
	STS  2016,R30
; 0000 0228 	// Pin0 Output/Pull configuration: Totempole/No
; 0000 0229 	// Pin0 Input/Sense configuration: Sense both edges
; 0000 022A 	// Pin0 Inverted: Off
; 0000 022B 	// Pin0 Slew Rate Limitation: Off
; 0000 022C 	PORTR.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2032,R30
; 0000 022D 	// Pin1 Output/Pull configuration: Totempole/No
; 0000 022E 	// Pin1 Input/Sense configuration: Sense both edges
; 0000 022F 	// Pin1 Inverted: Off
; 0000 0230 	// Pin1 Slew Rate Limitation: Off
; 0000 0231 	PORTR.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2033,R30
; 0000 0232 	// Interrupt 0 level: Disabled
; 0000 0233 	// Interrupt 1 level: Disabled
; 0000 0234 	PORTR.INTCTRL=(PORTR.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0235 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,2025
	ANDI R30,LOW(0xF0)
	STS  2025,R30
; 0000 0236 	// Pin0 Pin Change interrupt 0: Off
; 0000 0237 	// Pin1 Pin Change interrupt 0: Off
; 0000 0238 	PORTR.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  2026,R30
; 0000 0239 	// Pin0 Pin Change interrupt 1: Off
; 0000 023A 	// Pin1 Pin Change interrupt 1: Off
; 0000 023B 	PORTR.INT1MASK=0x00;
	STS  2027,R30
; 0000 023C }
	RET
; .FEND
;
;// Virtual Ports initialization
;void vports_init(void)
; 0000 0240 {
; 0000 0241 	// PORTA mapped to VPORT0
; 0000 0242 	// PORTB mapped to VPORT1
; 0000 0243 	PORTCFG.VPCTRLA=PORTCFG_VP1MAP_PORTB_gc | PORTCFG_VP0MAP_PORTA_gc;
; 0000 0244 	// PORTC mapped to VPORT2
; 0000 0245 	// PORTD mapped to VPORT3
; 0000 0246 	PORTCFG.VPCTRLB=PORTCFG_VP3MAP_PORTD_gc | PORTCFG_VP2MAP_PORTC_gc;
; 0000 0247 }
;
;// USARTC0 initialization
;void usartc0_init(void)
; 0000 024B {
_usartc0_init:
; .FSTART _usartc0_init
; 0000 024C 	// Note: The correct PORTC direction for the RxD, TxD and XCK signals
; 0000 024D 	// is configured in the ports_init function.
; 0000 024E 
; 0000 024F 	// Transmitter is enabled in Master SPI mode: 0
; 0000 0250 	// Set XCK (SCK)=0, TxD (MOSI)=0
; 0000 0251 	//PORTC.OUTCLR=0x0A;
; 0000 0252 	//PORTC.OUTSET=0x0A;
; 0000 0253 
; 0000 0254 	// Communication mode: Master SPI
; 0000 0255 	// SPI Mode: 1
; 0000 0256 	// Data Order: MSB First
; 0000 0257 	USARTC0.CTRLC=USART_CMODE_MSPI_gc | 0x00 | 0x02;
	LDI  R30,LOW(194)
	STS  2213,R30
; 0000 0258 	PORTC.PIN1CTRL&=~PORT_INVEN_bm;
	LDS  R30,1617
	ANDI R30,0xBF
	STS  1617,R30
; 0000 0259 	PORTC.PIN3CTRL&=~PORT_INVEN_bm;
	LDS  R30,1619
	ANDI R30,0xBF
	STS  1619,R30
; 0000 025A 
; 0000 025B 	// Receive complete interrupt: Disabled
; 0000 025C 	// Transmit complete interrupt: High Level
; 0000 025D 	// Data register empty interrupt: Disabled
; 0000 025E 	USARTC0.CTRLA=(USARTC0.CTRLA & (~(USART_RXCINTLVL_gm | USART_TXCINTLVL_gm | USART_DREINTLVL_gm))) | USART_RXCINTLVL_OFF ...
	LDS  R30,2211
	ANDI R30,LOW(0xC0)
	ORI  R30,LOW(0xC)
	STS  2211,R30
; 0000 025F 
; 0000 0260 	// Baudrate
; 0000 0261 	USARTC0.BAUDCTRLA=0x14;
	LDI  R30,LOW(20)
	STS  2214,R30
; 0000 0262 	USARTC0.BAUDCTRLB=((0x00 << USART_BSCALE_gp) & USART_BSCALE_gm) | 0x00;
	LDI  R30,LOW(0)
	STS  2215,R30
; 0000 0263 
; 0000 0264 	// Receiver: Off
; 0000 0265 	// Transmitter: On
; 0000 0266 	// Double transmission speed mode: Off
; 0000 0267 	// Multi-processor communication mode: Off
; 0000 0268 	USARTC0.CTRLB=(USARTC0.CTRLB & (~(USART_RXEN_bm | USART_TXEN_bm | USART_CLK2X_bm | USART_MPCM_bm | USART_TXB8_bm))) | U ...
	LDS  R30,2212
	ANDI R30,LOW(0xE0)
	ORI  R30,8
	STS  2212,R30
; 0000 0269 }
	RET
; .FEND
;
;// USARTC0 Transmitter buffer
;#define TX_BUFFER_SIZE_USARTC0 512
;char tx_buffer_usartc0[TX_BUFFER_SIZE_USARTC0];
;
;#if TX_BUFFER_SIZE_USARTC0 <= 256
;unsigned char tx_wr_index_usartc0=0,tx_rd_index_usartc0=0;
;#else
;unsigned int tx_wr_index_usartc0=0,tx_rd_index_usartc0=0;
;#endif
;
;#if TX_BUFFER_SIZE_USARTC0 < 256
;unsigned char tx_counter_usartc0=0;
;#else
;unsigned int tx_counter_usartc0=0;
;#endif
;
;// USARTC0 Transmitter interrupt service routine
;interrupt [USARTC0_TXC_vect] void usartc0_tx_isr(void)
; 0000 027D {
_usartc0_tx_isr:
; .FSTART _usartc0_tx_isr
	ST   -Y,R0
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 027E 	if (tx_counter_usartc0)
	MOV  R0,R6
	OR   R0,R7
	BREQ _0x6
; 0000 027F 	{
; 0000 0280 		--tx_counter_usartc0;
	MOVW R30,R6
	SBIW R30,1
	MOVW R6,R30
; 0000 0281 		USARTC0.DATA=tx_buffer_usartc0[tx_rd_index_usartc0++];
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	SBIW R30,1
	SUBI R30,LOW(-_tx_buffer_usartc0)
	SBCI R31,HIGH(-_tx_buffer_usartc0)
	LD   R30,Z
	STS  2208,R30
; 0000 0282 		#if TX_BUFFER_SIZE_USARTC0 != 256
; 0000 0283 		if (tx_rd_index_usartc0 == TX_BUFFER_SIZE_USARTC0) tx_rd_index_usartc0=0;
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x7
	CLR  R4
	CLR  R5
; 0000 0284 		#endif
; 0000 0285 	}
_0x7:
; 0000 0286 }
_0x6:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;// Write a character to the USARTC0 Transmitter buffer
;// USARTC0 is used as the default output device by the 'putchar' function
;#define _ALTERNATE_PUTCHAR_
;
;#pragma used+
;void putchar(char c)
; 0000 028E {
_putchar:
; .FSTART _putchar
; 0000 028F 	while (tx_counter_usartc0 == TX_BUFFER_SIZE_USARTC0);
	ST   -Y,R26
;	c -> Y+0
_0x8:
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R30,R6
	CPC  R31,R7
	BREQ _0x8
; 0000 0290 	#asm("cli")
	cli
; 0000 0291 	if (tx_counter_usartc0 || ((USARTC0.STATUS & USART_DREIF_bm)==0))
	MOV  R0,R6
	OR   R0,R7
	BRNE _0xC
	LDS  R30,2209
	ANDI R30,LOW(0x20)
	BRNE _0xB
_0xC:
; 0000 0292 	{
; 0000 0293 		tx_buffer_usartc0[tx_wr_index_usartc0++]=c;
	MOVW R30,R2
	ADIW R30,1
	MOVW R2,R30
	SBIW R30,1
	SUBI R30,LOW(-_tx_buffer_usartc0)
	SBCI R31,HIGH(-_tx_buffer_usartc0)
	LD   R26,Y
	STD  Z+0,R26
; 0000 0294 		#if TX_BUFFER_SIZE_USARTC0 != 256
; 0000 0295 		if (tx_wr_index_usartc0 == TX_BUFFER_SIZE_USARTC0) tx_wr_index_usartc0=0;
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R30,R2
	CPC  R31,R3
	BRNE _0xE
	CLR  R2
	CLR  R3
; 0000 0296 		#endif
; 0000 0297 		++tx_counter_usartc0;
_0xE:
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
; 0000 0298 	}
; 0000 0299 	else
	RJMP _0xF
_0xB:
; 0000 029A 	USARTC0.DATA=c;
	LD   R30,Y
	STS  2208,R30
; 0000 029B 	#asm("sei")
_0xF:
	sei
; 0000 029C }
	ADIW R28,1
	RET
; .FEND
;#pragma used-
;
;
;void main(void)
; 0000 02A1 {
_main:
; .FSTART _main
; 0000 02A2 	#define COUNT_PIX 240
; 0000 02A3 
; 0000 02A4 	// Declare your local variables here
; 0000 02A5 	unsigned char n,x,y,z;
; 0000 02A6 
; 0000 02A7 	// Interrupt system initialization
; 0000 02A8 	// Optimize for speed
; 0000 02A9 	#pragma optsize-
; 0000 02AA 	// Make sure the interrupts are disabled
; 0000 02AB 	#asm("cli")
;	n -> R17
;	x -> R16
;	y -> R19
;	z -> R18
	cli
; 0000 02AC 	// Low level interrupt: Off
; 0000 02AD 	// Round-robin scheduling for low level interrupt: Off
; 0000 02AE 	// Medium level interrupt: Off
; 0000 02AF 	// High level interrupt: On
; 0000 02B0 	// The interrupt vectors will be placed at the start of the Application FLASH section
; 0000 02B1 	n=(PMIC.CTRL & (~(PMIC_RREN_bm | PMIC_IVSEL_bm | PMIC_HILVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm))) |
; 0000 02B2 	PMIC_HILVLEN_bm;
	LDS  R30,162
	ANDI R30,LOW(0x38)
	ORI  R30,4
	MOV  R17,R30
; 0000 02B3 	CCP=CCP_IOREG_gc;
	LDI  R30,LOW(216)
	OUT  0x34,R30
; 0000 02B4 	PMIC.CTRL=n;
	STS  162,R17
; 0000 02B5 	// Set the default priority for round-robin scheduling
; 0000 02B6 	PMIC.INTPRI=0x00;
	LDI  R30,LOW(0)
	STS  161,R30
; 0000 02B7 	// Restore optimization for size if needed
; 0000 02B8 	#pragma optsize_default
; 0000 02B9 
; 0000 02BA 	// System clocks initialization
; 0000 02BB 	system_clocks_init();
	RCALL _system_clocks_init
; 0000 02BC 
; 0000 02BD 	// Ports initialization
; 0000 02BE 	ports_init();
	RCALL _ports_init
; 0000 02BF 
; 0000 02C0 	// Virtual Ports initialization
; 0000 02C1 	//vports_init();
; 0000 02C2 
; 0000 02C3 	// USARTC0 initialization
; 0000 02C4 	usartc0_init();
	RCALL _usartc0_init
; 0000 02C5 
; 0000 02C6 	// Globally enable interrupts
; 0000 02C7 	#asm("sei")
	sei
; 0000 02C8 
; 0000 02C9 	// Clear all
; 0000 02CA 	for(x=0;x<COUNT_PIX;x++)
	LDI  R16,LOW(0)
_0x11:
	CPI  R16,240
	BRSH _0x12
; 0000 02CB 	{
; 0000 02CC 		putchar(0x00);	// Green
	LDI  R26,LOW(0)
	RCALL _putchar
; 0000 02CD 		putchar(0x00);	// Red
	LDI  R26,LOW(0)
	RCALL _putchar
; 0000 02CE 		putchar(0x00);	// Blue
	LDI  R26,LOW(0)
	RCALL _putchar
; 0000 02CF 	}
	SUBI R16,-1
	RJMP _0x11
_0x12:
; 0000 02D0 	delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	CALL _delay_ms
; 0000 02D1 
; 0000 02D2 	z=0;
	LDI  R18,LOW(0)
; 0000 02D3 	while(1)
_0x13:
; 0000 02D4 	{
; 0000 02D5 		for(y=0;y<64;y++)
	LDI  R19,LOW(0)
_0x17:
	CPI  R19,64
	BRSH _0x18
; 0000 02D6 		{
; 0000 02D7 			for(x=0;x<COUNT_PIX;x++)
	LDI  R16,LOW(0)
_0x1A:
	CPI  R16,240
	BRSH _0x1B
; 0000 02D8 			{
; 0000 02D9 				putchar(z==0?y:0);	// Green
	CPI  R18,0
	BRNE _0x1C
	MOV  R30,R19
	RJMP _0x1D
_0x1C:
	LDI  R30,LOW(0)
_0x1D:
	MOV  R26,R30
	RCALL _putchar
; 0000 02DA 				putchar(z==1?y:0);	// Red
	CPI  R18,1
	BRNE _0x1F
	MOV  R30,R19
	RJMP _0x20
_0x1F:
	LDI  R30,LOW(0)
_0x20:
	MOV  R26,R30
	RCALL _putchar
; 0000 02DB 				putchar(z==2?y:0);	// Blue
	CPI  R18,2
	BRNE _0x22
	MOV  R30,R19
	RJMP _0x23
_0x22:
	LDI  R30,LOW(0)
_0x23:
	MOV  R26,R30
	RCALL _putchar
; 0000 02DC 			}
	SUBI R16,-1
	RJMP _0x1A
_0x1B:
; 0000 02DD 			while(tx_counter_usartc0);	// Warten bis alle Bytes gesendet
_0x25:
	MOV  R0,R6
	OR   R0,R7
	BRNE _0x25
; 0000 02DE 			delay_us(20);
	__DELAY_USB 213
; 0000 02DF 		}
	SUBI R19,-1
	RJMP _0x17
_0x18:
; 0000 02E0 		for(;y>0;y--)
_0x29:
	CPI  R19,1
	BRLO _0x2A
; 0000 02E1 		{
; 0000 02E2 			for(x=0;x<COUNT_PIX;x++)
	LDI  R16,LOW(0)
_0x2C:
	CPI  R16,240
	BRSH _0x2D
; 0000 02E3 			{
; 0000 02E4 				putchar(z==0?y:0);	// Green
	CPI  R18,0
	BRNE _0x2E
	MOV  R30,R19
	RJMP _0x2F
_0x2E:
	LDI  R30,LOW(0)
_0x2F:
	MOV  R26,R30
	RCALL _putchar
; 0000 02E5 				putchar(z==1?y:0);	// Red
	CPI  R18,1
	BRNE _0x31
	MOV  R30,R19
	RJMP _0x32
_0x31:
	LDI  R30,LOW(0)
_0x32:
	MOV  R26,R30
	RCALL _putchar
; 0000 02E6 				putchar(z==2?y:0);	// Blue
	CPI  R18,2
	BRNE _0x34
	MOV  R30,R19
	RJMP _0x35
_0x34:
	LDI  R30,LOW(0)
_0x35:
	MOV  R26,R30
	RCALL _putchar
; 0000 02E7 			}
	SUBI R16,-1
	RJMP _0x2C
_0x2D:
; 0000 02E8 			while(tx_counter_usartc0);	// Warten bis alle Bytes gesendet
_0x37:
	MOV  R0,R6
	OR   R0,R7
	BRNE _0x37
; 0000 02E9 			delay_us(20);
	__DELAY_USB 213
; 0000 02EA 		}
	SUBI R19,1
	RJMP _0x29
_0x2A:
; 0000 02EB 		z++;
	SUBI R18,-1
; 0000 02EC 		if(z>2)z=0;
	CPI  R18,3
	BRLO _0x3A
	LDI  R18,LOW(0)
; 0000 02ED 	}
_0x3A:
	RJMP _0x13
; 0000 02EE }
_0x3B:
	RJMP _0x3B
; .FEND

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_tx_buffer_usartc0:
	.BYTE 0x200

	.CSEG

	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x1F40
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
